.\" $NetBSD: wsconsctl.8,v 1.26 2008/11/29 05:52:32 jnemeth Exp $
.\"
.\" Copyright (c) 1998, 2004 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Juergen Hannken-Illjes.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"/
.Dd June 9, 2009
.Dt WSCONSCTL 8
.Os
.Sh NAME
.Nm wsconsctl
.Nd get or set wscons state
.Sh SYNOPSIS
.Nm
.Op Fl dkmn
.Op Fl f Ar file
.Fl a
.Nm
.Op Fl dkmn
.Op Fl f Ar file
.Ar name ...
.Nm
.Op Fl dkmn
.Op Fl f Ar file
.Fl w
.Ar name Ns Li = Ns Ar value ...
.Nm
.Op Fl dkmn
.Op Fl f Ar file
.Fl w
.Ar name Ns Li += Ns Ar value ...
.Sh DESCRIPTION
The
.Nm
command displays or sets various wscons system driver variables.
If a list of variables is present on the command line, then
.Nm
prints the current value of those variables for the specified device.
.Bl -tag -width Ds
.It Fl a
Specify all variables for the device.
.It Fl d
Select the display portion of the device.
.It Fl f Ar file
Specify an alternative control device.
.It Fl k
Select the keyboard portion of the device (this is the default).
.It Fl m
Select the mouse portion of the device.
.It Fl n
Suppress the printing of the variable name in the output -
only the value will appear.
.It Fl w
Set or modify the specified variables to the given values.
The value can be specified as either an absolute value, by using the
.Ql =
symbol or as a relative value, by using the
.Ql +=
symbol.
See the
.Sx EXAMPLES
section for more details.
.El
.Pp
The
.Nm
utility can be used to view and modify aspects of the keyboard,
display, and mouse, using the standard, machine-independent
workstation console device driver
.Xr wscons 4 .
.Pp
The keyboard type can be modified, the keyboard bell's pitch,
period, and duration can be modified, the
.Ar typematic
value can be changed, and the keyboard encoding can be modified
to switch keys, should the user find a keyboard's default layout
difficult to use.
The keyboard types and other relevant definitions
can all be found in the
.Pa /usr/include/dev/wscons/wsksymdef.h
file.
.Pp
The mouse types are defined in the
.Pa /usr/include/dev/wscons/wsconsio.h
file.
.Pp
The display types, height, width, depth (bits per pixel), color
map size, and color map are defined in the
.Pa /usr/include/dev/wscons/wsconsio.h
file.
There are also definitions relating to video control and cursor
control, which are not applicable to all display types, and to text
emulation and graphics (mapped) modes.
.Pp
In addition to British, US, and US-Dvorak keyboard encodings, support
currently exists for the following languages: Belgian, Danish, Finnish,
French, German, Greek, Hungarian, Italian, Japanese, Norwegian, Polish,
Portugese, Russian, Spanish, Swedish, Swiss, and Ukrainian.
Additionally, a user-defined encoding is supported.
.Sh FILES
.Bl -tag -width /dev/wsmouse
.It Pa /dev/wskbd
keyboard control device
.It Pa /dev/wsmouse
mouse control device
.It Pa /dev/ttyE0
display control device
.El
.Sh EXAMPLES
The following are just a few examples of
.Nm
and its functionality.
.Pp
.Dl wsconsctl -w encoding=uk
.Pp
Set a UK keyboard encoding.
.Pp
.Dl wsconsctl -w map+="keysym Caps_Lock = Control_L"
.Pp
Modify the current keyboard encoding so that when the
.Ar Caps Lock
key is pressed, the same encoding sequence as
.Ar Left Control
is sent.
For a full list of keysyms and keycodes, please refer to the
.Pa /usr/include/dev/wscons/wsksymdef.h
file.
.Pp
.Dl wsconsctl -w encoding=us.swapctrlcaps
.Pp
Set a US keyboard encoding, with the
.Ar Caps Lock
and
.Ar Left Control
keys swapped.
The
.Ar .swapctrlcaps
encoding does not work for all national keyboard encodings.
For most purposes, the ability to set the value returned by the
.Ar Caps Lock
key is enough - see the previous example for details.
.Pp
.Dl wsconsctl -w bell.pitch=1200
.Pp
Set the bell pitch to be 1200.
.Pp
.Dl wsconsctl -w bell.pitch+=200
.Pp
Add 200 to the current pitch of the bell.
.Pp
.Dl wsconsctl -d -w msg.kernel.attrs=color,hilit msg.kernel.bg=red msg.kernel.fg=brown
.Pp
Set the color of kernel messages to brown on red with the highlighting
flag set (becoming yellow on red).
.Pp
.Dl wsconsctl -w repeat.del1=200 repeat.deln=50
.Pp
Set the initial delay for keyboard auto repeat to 200ms, and subsequent
delays to 50ms.
.Pp
.Dl wsconsctl -w repeat.del1=0
.Pp
Turn off auto repeat.
.Pp
.Dl wsconsctl -d -w scroll.fastlines=50
.Pp
If scroll support is enabled in the kernel, set the number of lines
used in the fast scroll function to 50.
.Pp
.Dl wsconsctl -d -w scroll.slowlines=2
.Pp
If scroll support is enabled in the kernel, set the number of lines
used in the slow scroll function to 2.
In order to use this function, you have to have
.Dv Cmd_ScrollSlowDown
and
.Dv Cmd_ScrollSlowUp
defined in your keyboard map.
.Sh SEE ALSO
.Xr pckbd 4 ,
.Xr wscons 4 ,
.Xr wscons.conf 5 ,
.Xr wsconscfg 8 ,
.Xr wsfontload 8
.Sh HISTORY
The
.Nm
command first appeared in
.Nx 1.4 .
